- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# DSA Struct Reference

`#include <gfpcrypt.h>`

Inheritance diagram for DSA:

List of all members.

## Detailed Description

DSA

Definition at line 384 of file gfpcrypt.h.

## Public Types
enum | { MIN_PRIME_LENGTH = 1024, MAX_PRIME_LENGTH = 1024, PRIME_LENGTH_MULTIPLE = 64 }
| FIPS 186-2 Change Notice 1 changed the minimum modulus length to 1024. More...
typedef PK_FinalTemplate< DL_SignerImpl< SchemeOptions > > | Signer
| implements PK_Signer interface
typedef PK_FinalTemplate< DL_VerifierImpl< SchemeOptions > > | Verifier
| implements PK_Verifier interface
typedef DL_PublicKey_GFP< DL_GroupParameters_DSA > | PublicKey
typedef DL_PrivateKey_WithSignaturePairwiseConsistencyTest< DL_PrivateKey_GFP< DL_GroupParameters_DSA >, DSA > | PrivateKey
## Static Public Member Functions
static const char *__cdecl | StaticAlgorithmName ()
static bool __cdecl | GeneratePrimes (const byte *seed, unsigned int seedLength, int &counter, Integer &p, unsigned int primeLength, Integer &q, bool useInputCounterValue=false)
| Generate DSA primes according to NIST standard.
static bool __cdecl | IsValidPrimeLength (unsigned int pbits)

## Member Enumeration Documentation

anonymous enum

FIPS 186-2 Change Notice 1 changed the minimum modulus length to 1024.

Enumerator:

  MIN_PRIME_LENGTH |
  MAX_PRIME_LENGTH |
  PRIME_LENGTH_MULTIPLE |

Definition at line 405 of file gfpcrypt.h.

## Member Function Documentation

bool DSA::GeneratePrimes | ( | const byte * | seed,
|  | unsigned int | seedLength,
|  | int & | counter,
|  | Integer & | p,
|  | unsigned int | primeLength,
|  | Integer & | q,
|  | bool | useInputCounterValue = `false` |
| ) |  |  | `[static]`

Generate DSA primes according to NIST standard.

Both seedLength and primeLength are in bits, but seedLength should be a multiple of 8. If useInputCounterValue == true, the counter parameter is taken as input, otherwise it's used for output

Definition at line 61 of file dsa.cpp.

References HashTransformation::CalculateDigest(), Integer::Decode(), IteratedHashWithStaticTransform< word32, BigEndian, 64, 20, SHA1 >::DIGESTSIZE, and Integer::GetBit().

Referenced by DL_GroupParameters_DSA::GenerateRandom().

The documentation for this struct was generated from the following files:

- gfpcrypt.h
- dsa.cpp